<?

function node_include($include) {
 global $DEBUG, $INCLUDE_CHECKED, $INCLUDE, $INCLUDE_HITS, $INCLUDE_LOADED, $INC_COUNT, $INCLUDE_PERF, $INCLUDE_TOT, $DESTROY_FUNC;

 if ($INCLUDE_CHECKED[$include]) {
 if ($DEBUG["echo"] && $DEBUG["include"]) echo "node_include: requesting duplicate include '$include'<br>\n";
 $INCLUDE_HITS++;
 return false;
 }

 $funcs = array();

 $EXEC_FUNC = array();

 $debug = $DEBUG["echo"] && $DEBUG["include"];

 if ($DEBUG["echo"] && $DEBUG["trace"]) echo "node_include: requesting include '$include'<br>\n";

 if ($debug) {
 echo "------[$include] (by function) -------<br>\n";
 }
 
 if ($DEBUG["echo"]) $t_start = microtime();

 
 if ($include) $funcs[0] = $include;

 $c = count($funcs) - 1;

 while ($c >= 0) {
 if ($debug) echo "stack($c): ";

 if ($INCLUDE_CHECKED[$funcs[$c]]) {
 if ($DEBUG["echo"] && $DEBUG["include"]) echo "duplicate include '".$funcs[$c]."'.<br>\n";
 unset($funcs[$c]);
 $c--;
 $INCLUDE_HITS++;
 continue;
 }
 if (isset($INCLUDE[$funcs[$c]])) $INCLUDE_CHECKED[$funcs[$c]] = true;

 if (is_array($f = $INCLUDE[$funcs[$c]])) {
 if ($debug) echo "include: ".$funcs[$c]." -> Array(".count($f).")<br>\n";
 krsort($f);
 reset($f);
 unset($funcs[$c]);
 $c--;
 while (list($k, $v) = each($f)) $funcs[++$c] = $v;
 } else if ($INCLUDE[$funcs[$c]]) {
 if ($debug) echo "include: ".$funcs[$c]." -> ".$INCLUDE[$funcs[$c]]."<br>\n";
 $funcs[$c] = $INCLUDE[$funcs[$c]];
 } else if (file_exists($funcs[$c])) {
 if (!$INCLUDE_LOADED[$funcs[$c]]) {

 $INC_COUNT++;
 $INCLUDE_LOADED[$funcs[$c]] = true;

 $t1 = microtime();

 include($funcs[$c]);

 if ($debug && function_exists("calctime") ) {
 $t2 = microtime();
 echo "include: (".$funcs[$c].")<br>\n";
 $t = calctime($t1,$t2,5);
 echo $t."<br>\n";
 $INCLUDE_PERF[$t][] = $funcs[$c];
 }
 }
 unset($funcs[$c]);
 $c--;
 } else {
 warning(20, "include ".$funcs[$c]." not found.");
 unset($funcs[$c]);
 $c--;
 }
 }

 if ($DEBUG["echo"] && function_exists("calctime")) {
 $t_end = microtime();
 $INCLUDE_TOT += calctime($t_start, $t_end, 5);
 }

 node_exec_func($EXEC_FUNC);
}

global $NODEFUNC_STACK;
$NODEFUNC_STACK = 0;

function node_func($Function,$exec = false) {
 global $NODE_FUNCTION, $DEBUG, $NODEFUNC_STACK;
 $function = strtolower($Function);
 if (!isset($NODE_FUNCTION[$function])) halt(7,"node_func: function '$function' is not registered.");
 $debug = $DEBUG["trace"] && $DEBUG["echo"];
 
 if ($debug) $t1 = microtime();

 node_include($NODE_FUNCTION[$function]);

 $rs = false;

 if ($exec) {
 if ($debug) {
 for ($i = 0; $i < $NODEFUNC_STACK; $i++) echo "|--";
 echo "calling node_func: <B>$Function (";
 $NODEFUNC_STACK++;
 }

 $params = array();
 $c = func_num_args();
 if ($c > 2) {
 for ($i = 2; $i < $c; $i++) {
 if ($debug) {
 if (count($params)) echo ",";
 echo func_get_arg($i);
 }
 $params[] = func_get_arg($i);
 }
 }

 if ($debug && function_exists("calctime")) {
 $t2 = microtime();
 $t = calctime($t1,$t2,5);
 echo ");</b> ($t)<br>\n";
 }
 
 $rs = call_user_func_array($Function, $params);
 
 if ($debug && function_exists("calctime")) {
 $NODEFUNC_STACK--;
 $t3 = microtime();
 $t = calctime($t2, $t3, 5);
 if (is_string($rs) && strlen($rs) > 40) $drs = substr($rs,0,40).".."; else $drs = $rs;
 echo "result: '$rs' ($t)<br>\n";
 }
 
 }

 return $rs;
}

function node_var($var) {
 global $NODE_VAR;
 if (!$NODE_VAR[$var]) halt(7,"node_var: variable '$var' is not registered.");
 
 node_include($NODE_VAR[$var]);

 global $$var;
 return $$var;
}

function node_class($class) {
 $class = strtolower($class);
 global $NODE_CLASS, $INCLUDE;
 $classInc = (isset($NODE_CLASS[$class]))?$NODE_CLASS[$class]:$class;
 if ( $classInc === FALSE ) return;
 if (!$classInc) halt(7,"node_class: class '$class' is not registered.");
 
 node_include($classInc);

}

function node_exec_func($exec_func) {
 global $DEBUG;
 if (!is_array($exec_func) || count($exec_func) == 0) return;
 $debug = $DEBUG["echo"] && $DEBUG["include"]; 

 while (list($k, $func) = each($exec_func)) {
 if (function_exists($func)) {
 if ($debug) $t1 = microtime();
 $func();
 if ($debug && function_exists("calctime")) {
 $t2 = microtime();
 echo "exec function: $func<br>\n";
 echo calctime($t1,$t2,5)."<br>\n<br>\n";
 }
 }
 }
}

?>
