<?

GUIFactory::setMainGui("main");

node_class("htmlform3");
node_class("tabcomponent");
node_class("selectcomponent");
node_class("codeparser");
node_class("textcomponent");
node_class("checkboxcomponent");
node_class("textareacomponent");
node_class("labelcomponent");
node_class("nodefactory");
node_class("itemlistcomponent");
node_class("dateformatter");
node_class("booleanformatter");

if (!perm($USER_ID, T_DEVTOOLS, '', 7)) {
 halt(7, "Permission denied!");
}

mysession_var_reg("JAVAADMIN_CODE");

class AnalyzeAction extends GenericAction {
 function AnalyzeAction() {
 parent::GenericAction(null, "analyze", i18n("analyze"));
 }

 function performAction($ids) {
 global $JS, $STAG;
 if (is_array($ids)) {
 reset($ids);
 while (list($key, $val) = each($ids)) {
 $JS .= "window.open('$STAG&do=15403&analysis_id=$val','analysis_$val','width=800,height=400,status=no,scrollbars=yes');\n";
 }
 }
 }
}

class DeleteAction extends GenericAction {
 function DeleteAction() {
 global $ICO_DELETE;
 parent::GenericAction($ICO_DELETE, "del", i18n("delete"));
 }

 function performAction($ids) {
 if (is_array($ids) && sizeof($ids) > 0) {
 $sql = "DELETE FROM dirtanalysis WHERE id in (".implode(", ", sqlf_value_array($ids)).")";
 query($sql);
 }
 }
}

function execAction( &$form, $param ) {

 global $JAVAADMIN_CODE, $FEATURE;
 
 $tab =& $form->getComponent( "tab" );
 $action = $tab->getActiveTabName();
 $actionComp =& $tab->getTab($action);
 
 $javaParser =& CodeParser::getJavaParser();

 $code = "";
 
 if ($action == "connect") {
 $urlComp = $actionComp->getComponent("url");
 $url = $urlComp->getText();
 
 $javaParser->setPortalUrl($url);
 $javaParser->disconnect();
 $javaParser->initConnection();
 }
 if ($action == "pub") {

 $dirt =& $actionComp->getComponent("dirt");
 $dirtlimit =& $actionComp->getComponent("dirtlimit");

 $run =& $actionComp->getComponent("run");
 $force =& $actionComp->getComponent("force");
 $stop =& $actionComp->getComponent("stop");

 if ($run->isChecked()) {

 if ($dirt->isChecked()) {
 $limit = (int) $dirtlimit->getText();
 
 $sql = "UPDATE page SET status = 1 WHERE status = 2";
 if ($limit) $sql .= " LIMIT ".sqlf_limit_num($limit);
 query($sql);
 }
 
 $code = $javaParser->startPublish($force->isChecked());
 } else if ($stop->isChecked()) {
 $code = $javaParser->stopPublish();
 } else {
 $code = $javaParser->getPublishInfo();
 }
 }
 if ($action == "render" || $action == "parse" || $action == "diff") {
 
 $idComp =& $actionComp->getComponent("id");
 $typeComp =& $actionComp->getComponent("type");
 $showErrors =& $actionComp->getComponent("showErrors");
 $eval =& $actionComp->getComponent("eval");
 $editMode =& $actionComp->getComponent("editMode");
 $handleDeps =& $actionComp->getComponent("handleDeps");
 $simulate =& $actionComp->getComponent("simulate");
 $dependencyId =& $actionComp->getComponent("dependencyId");
 $tagids =& $actionComp->getComponent("tagids");
 $versionTimestamp =& $actionComp->getComponent("versionTimestamp");
 $diffTimestamp =& $actionComp->getComponent("diffTimestamp");
 $diffSource =& $actionComp->getComponent("diffSource");
 
 $baseObj =& NodeFactory::getInstanceOf($typeComp->getText(), $idComp->getText());

 if ( $baseObj === NULL ) {
 
 $idComp->addError( new NodeException( i18n("Invalid type or id") ) );
 
 } else {
 
 if ($action == "render") {
 
 $code = $javaParser->render($baseObj, $showErrors->isChecked(), $eval->isChecked(), $editMode->getSingleSelection(), $handleDeps->isChecked(), $simulate->isChecked(), $dependencyId->getText(), $tagids->isChecked(), $versionTimestamp->getText() );
 } else if ($action == "parse") {
 
 $source =& $actionComp->getComponent("source");
 
 $code = $javaParser->parse($baseObj, $source->getText(), $showErrors->isChecked(), $eval->isChecked(), 
 $editMode->getSingleSelection(), $handleDeps->isChecked());
 } else if ($action == "diff") {
 $code = $javaParser->diff($baseObj, $showErrors->isChecked(), $eval->isChecked(), $editMode->getSingleSelection(), $handleDeps->isChecked(), $simulate->isChecked(), $dependencyId->getText(), $tagids->isChecked(), $versionTimestamp->getText(), $diffTimestamp->getText(), $diffSource->isChecked() );
 }
 }
 }
 if ($action == "clear") {
 
 $type =& $actionComp->getComponent("type");
 $id =& $actionComp->getComponent("id");
 
 $code = $javaParser->clearCache($type->getText(), $id->getText());
 }
 if ($action == "trigger") {

 $type =& $actionComp->getComponent("type");
 $id =& $actionComp->getComponent("id");
 $prop =& $actionComp->getComponent("property");
 $eventComp =& $actionComp->getComponent("mask");
 $events =& $eventComp->getSelection();
 $mask = 0;
 reset($events);
 while (list($key, $val) = each($events)) {
 $mask |= $val;
 }
 $simulate =& $actionComp->getComponent("simulate");
 $code = $javaParser->triggerEvent($type->getText(), $id->getText(), split(",", $prop->getText()), $mask, $simulate->isChecked() ? 2 : 0);
 }

 if ($FEATURE["log_dirt_events"] && $action == "dirtanalysis") {
 $active =& $actionComp->getComponent("active");
 $threshold =& $actionComp->getComponent("threshold");
 $retain =& $actionComp->getComponent("retain");
 $info = array();
 $info["event_logging_activated"] = $active->isChecked();
 $info["event_logging_threshold"] = $threshold->getText();
 $info["event_logging_retainedfiles"] = $retain->getText();
 setEventAnalysisInfo($info);
 }

 $JAVAADMIN_CODE = $code;
}

$form = new HtmlForm3("javaadmin");
if ($form->isNew()) {

 $javaParser =& CodeParser::getJavaParser();
 
 $connect = new ListComponent();
 $connect->setComponent( "url", new TextComponent( i18n("Url"), true, $javaParser->getPortalUrl() ) );
 $connect->setComponent( "remote", new LabelComponent( i18n("Remote Address"), $REMOTE_ADDR ) );
 
 if ( !$FEATURE["javaparser"] ) {
 $connect->setComponent( "nofeature", new LabelComponent( i18n("Warning:"), i18n("Feature javaparser not enabled") ) );
 }

 $pub = new ListComponent();
 $pub->setComponent( "dirt", new CheckBoxComponent( i18n( "Dirt before publishing" ) ) );
 $pub->setComponent( "dirtlimit", new TextComponent( i18n( "Max dirt"), true ) );
 $pub->setComponent( "run", new CheckBoxComponent( i18n( "Run publish" ) ) );
 $pub->setComponent( "force", new CheckBoxComponent( i18n( "Ignore errors" ) ) );
 $pub->setComponent( "stop", new CheckBoxComponent( i18n( "Stop publish" ) ) );
 
 $render = new ListComponent();
 $render->setComponent( "type", new TextComponent( "Type", true ) );
 $render->setComponent( "id", new TextComponent( "Id", true ) );
 $render->setComponent( "showErrors", new CheckBoxComponent( i18n( "Show errors" ) ) );
 $render->setComponent( "eval", new CheckBoxComponent( i18n( "Evaluate" ) ) );
 $render->setComponent( "editMode", new SelectComponent( i18n( "Editmode"), 
 array( "publish"=>i18n("Publish"), "preview"=>i18n("Preview"), "portal"=>i18n("Portal"), "edit"=>i18n("Edit") ), "publish" ) );
 $render->setComponent( "handleDeps", new CheckBoxComponent( i18n( "Handle Dependecies" ) ) );
 $render->setComponent( "simulate", new CheckBoxComponent( i18n("Simulate") ) );
 $render->setComponent( "dependencyId", new TextComponent( i18n("DependencyId"), true ) );
 $render->setComponent( "tagids", new CheckBoxComponent( i18n( "Render tag ids" ) ) );
 $render->setComponent( "versionTimestamp", new TextComponent( i18n( "VersionTimestamp" ), true, "-1" ) );

 $diff = new ListComponent();
 $diff->setComponent( "type", new TextComponent( "Type", true ) );
 $diff->setComponent( "id", new TextComponent( "Id", true ) );
 $diff->setComponent( "showErrors", new CheckBoxComponent( i18n( "Show errors" ) ) );
 $diff->setComponent( "eval", new CheckBoxComponent( i18n( "Evaluate" ) ) );
 $diff->setComponent( "editMode", new SelectComponent( i18n( "Editmode"), 
 array( "publish"=>i18n("Publish"), "preview"=>i18n("Preview"), "portal"=>i18n("Portal"), "edit"=>i18n("Edit") ), "publish" ) );
 $diff->setComponent( "handleDeps", new CheckBoxComponent( i18n( "Handle Dependecies" ) ) );
 $diff->setComponent( "simulate", new CheckBoxComponent( i18n("Simulate") ) );
 $diff->setComponent( "dependencyId", new TextComponent( i18n("DependencyId"), true ) );
 $diff->setComponent( "tagids", new CheckBoxComponent( i18n( "Render tag ids" ) ) );
 $diff->setComponent( "versionTimestamp", new TextComponent( i18n( "VersionTimestamp" ), true, "-1" ) );
 $diff->setComponent( "diffTimestamp", new TextComponent( i18n( "DiffTimestamp" ), true, "-1" ) );
 $diff->setComponent( "diffSource", new CheckBoxComponent( i18n( "Diff Source" ) ) );

 $parse = new ListComponent();
 $parse->setComponent( "type", new TextComponent( "Type", true ) );
 $parse->setComponent( "id", new TextComponent( "Id", true ) );
 $parse->setComponent( "showErrors", new CheckBoxComponent( i18n( "Show errors" ) ) );
 $parse->setComponent( "eval", new CheckBoxComponent( i18n( "Evaluate" ) ) );
 $parse->setComponent( "editMode", new SelectComponent( i18n( "Editmode"), 
 array( "publish"=>i18n("Publish"), "preview"=>i18n("Preview"), "portal"=>i18n("Portal"), "edit"=>i18n("Edit") ), "publish" ) );
 $parse->setComponent( "handleDeps", new CheckBoxComponent( i18n( "Handle Dependecies" ) ) );
 $parse->setComponent( "source", new TextAreaComponent( i18n("Template"), true) );

 $clear = new ListComponent();
 $clear->setComponent( "hit", new LabelComponent( "Hint", "Try ALL/ALL to clear all caches" ) );
 $clear->setComponent( "type", new TextComponent( "Type", true ) );
 $clear->setComponent( "id", new TextComponent( "Id", true ) );

 $trigger = new ListComponent();
 $trigger->setComponent( "type", new TextComponent( "Type", true ) );
 $trigger->setComponent( "id", new TextComponent("Id", true));
 $trigger->setComponent("property", new TextComponent("prop", true));
 $mask = new SelectComponent(i18n("Eventmask"),
 array(0x7FFFFFFF => "ALL", 0x1 => "CREATE", 0x2 => "UPDATE", 0x4 => "DELETE", 0x8 => "MOVE", 0x10 => "CHILD", 0x20 => "PARENT", 0x40 => "NOTIFY", 0x80 => "MAINTENANCE_PUBLISH", 0x100 => "MAINTENANCE_DELAY", 0x200 => "MAINTENANCE_REPUBLISH", 0x400 => "MAINTENANCE_MARKPUBLISHED", 0x10000 => "EVENT_CN_CONTENT", 0x20000 => "EVENT_CN_PAGESTATUS"), "mask");
 $mask->enableMultipleSelect($mask->size());
 $trigger->setComponent("mask", $mask);
 $trigger->setComponent("simulate", new CheckBoxComponent("simulate", true));

 if ($FEATURE["log_dirt_events"]) {
 $eventAnalysis = new ListComponent();

 $eaActive = new CheckBoxComponent(i18n("active"));
 $eventAnalysis->setComponent( "active", $eaActive );

 $eaThreshold = new TextComponent( i18n("event_analysis_threshold"), true);
 $eaThreshold->setRegex("[0-9]+", i18n('number_natural'));
 $eventAnalysis->setComponent("threshold", $eaThreshold);

 $eaRetain = new TextComponent(i18n("event_analysis_retain"), true);
 $eaRetain->setRegex("[0-9]+", i18n('number_natural'));
 $eventAnalysis->setComponent("retain", $eaRetain);
 
 $dirtanalysis = new SQLDatasource("dirtanalysis", "id, finished, timestamp, dirted, sid, obj_id, obj_type, action", "dirtanalysis");
 $dirtanalysis->addColumn("obj_type", i18n("object type"), true, true);
 $dirtanalysis->addColumn("obj_id", i18n("object id"), true, true);
 $dirtanalysis->addColumn("action", i18n("action"), true, true);
 $dirtanalysis->addColumn("timestamp", i18n("time"), true, true);
 $dirtanalysis->addColumn("dirted", i18n("dirted"), true, true);
 $dirtanalysis->addColumn("finished", i18n("finished"), true, true);
 $dirtanalysis->addFormatter("finished", new BooleanFormatter( 'finished' ));
 $dirtanalysis->addFormatter("timestamp", new DateFormatter("timestamp"));
 $dirtanalysis->addAction(new AnalyzeAction());
 $dirtanalysis->addAction(new DeleteAction());

 $list = new ItemList3("dirtanalysis", $dirtanalysis );
 $eventAnalysis->setComponent( "dirtanalysis", new ItemListComponent(NULL, $list));
 }

 $tab = new tabcomponent();
 $tab->settab("connect", i18n("connect"), $connect);
 $tab->settab("pub", i18n("publish"), $pub);
 $tab->settab("render", i18n("render"), $render);
 $tab->settab("diff", i18n("diff"), $diff);
 $tab->settab("parse", i18n("parse"), $parse);
 $tab->settab("clear", i18n("clear cache"), $clear);
 $tab->settab("trigger", i18n("trigger event"), $trigger);
 if ($FEATURE["log_dirt_events"]) {
 $tab->settab("dirtanalysis", i18n( "Recorded dirt analysis"), $eventAnalysis );
 }
 
 $form->addComponent( "tab", $tab );

 $form->addButton( "ok", new Button( i18n( "Execute" ) ), new SimpleFormAction( "execAction" ), TRUE );

 $form->setHeader( i18n("Java.Admin"), $ICO_JAVAADMIN );

 $JAVAADMIN_CODE = "";
} else {
 if ($FEATURE["log_dirt_events"]) {
 $itemlistcomp =& $form->resolveComponent("tab.dirtanalysis.dirtanalysis");
 $itemlist =& $itemlistcomp->getList();
 $ds =& $itemlist->getDatasource();
 $ds->setDBHandle($DB);
 }
}

if ($FEATURE["log_dirt_events"]) {
 $info = getEventAnalysisInfo();
 $activeComp =& $form->resolveComponent("tab.dirtanalysis.active");
 $activeComp->setSelection($info["event_logging_activated"]);
 $thresholdComp =& $form->resolveComponent("tab.dirtanalysis.threshold");
 $thresholdComp->setText($info["event_logging_threshold"]);
 $retainComp =& $form->resolveComponent("tab.dirtanalysis.retain");
 $retainComp->setText($info["event_logging_retainedfiles"]);
}

function getEventAnalysisInfo() {
 $info = array("event_logging_activated" => false, "event_logging_threshold" => 1000, "event_logging_retainedfiles" => 100);
 
 $sql = "SELECT * FROM nodesetup WHERE name LIKE 'event_logging_%'";
 $rs = query($sql);
 for($i = 0; $i < $rs["num"]; ++$i) {
 switch($rs["arr"][$i]["name"]) {
 case "event_logging_activated":
 $info["event_logging_activated"] = $rs["arr"][$i]["intvalue"] == 0 ? false : true;
 break;
 case "event_logging_threshold":
 case "event_logging_retainedfiles":
 $info[$rs["arr"][$i]["name"]] = $rs["arr"][$i]["intvalue"];
 break;
 }
 }

 return $info;
}

function setEventAnalysisInfo($info) {
 insertOrUpdateNodesetup("event_logging_activated", $info["event_logging_activated"] ? 1 : 0);
 insertOrUpdateNodesetup("event_logging_threshold", $info["event_logging_threshold"]);
 insertOrUpdateNodesetup("event_logging_retainedfiles", $info["event_logging_retainedfiles"]);
}

function insertOrUpdateNodesetup($name, $intvalue) {
 $sql = "SELECT count(*) c FROM nodesetup WHERE name = '".sqlf_escaped($name)."'";
 $rs = query($sql);
 if ($rs["arr"][0]["c"] == 0) {
 $sql = "INSERT INTO nodesetup (name, intvalue) VALUES ('".sqlf_escaped($name)."', ".sqlf_value($intvalue).")";
 } else {
 $sql = "UPDATE nodesetup SET intvalue = ".sqlf_value($intvalue)." WHERE name = '".sqlf_escaped($name)."'";
 }

 query($sql);
}

?>
